<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;

class Branch extends \Zeedhi\Framework\Controller\Simple {

	protected $branchService;
	private $useDarkMode;
	private $environment;
	private $bindPopupKeys;
	public function __construct(
		\Service\Branch $branchService,
		\Lib\Environment $environment,
		$useDarkMode,
		$bindPopupKeys,
		$sortItemsByComboOrder
	) {
		$this->branchService = $branchService;
		$this->environment = $environment;
		$this->useDarkMode = $useDarkMode;
		$this->bindPopupKeys = $bindPopupKeys;
		$this->sortItemsByComboOrder = $sortItemsByComboOrder;
	}

	public function getBranch(Request $request, Response $response){
		try {
			$branch = $this->branchService->getBranch();

			if (empty($branch)) {
				throw new \Exception('Não existem filiais cadastradas.');
			}

			$useDarkModeParam = $this->environment->getSessionValue('useDarkMode');
			if ($useDarkModeParam) {
				$useDarkMode = $useDarkModeParam;
			} else {
				$useDarkMode = $this->useDarkMode;
				$this->environment->setSessionValue('useDarkMode', $this->useDarkMode);
			}

			$bindPopupKeys = $this->environment->getSessionValue('bindPopupKeys');
			if ($bindPopupKeys) {
				$bindPopupKeys = $bindPopupKeys;
			} else {
				$bindPopupKeys = $this->bindPopupKeys;
				$this->environment->setSessionValue('bindPopupKeys', false);
			}

			$sortItemsByComboOrder = $this->environment->getSessionValue('sortItemsByComboOrder');
			if ($sortItemsByComboOrder) {
				$sortItemsByComboOrder = $sortItemsByComboOrder;
			} else {
				$sortItemsByComboOrder = $this->sortItemsByComboOrder;
				$this->environment->setSessionValue('sortItemsByComboOrder', false);
			}

		 	$response->addDataSet(new DataSet('branch', array('error' => false, 'branch'=> $branch, 'useDarkMode' => $useDarkMode, 'bindPopupKeys' => $bindPopupKeys, 'sortItemsByComboOrder' => $sortItemsByComboOrder)));
		} catch (\Exception $e) {
			$response->addDataSet(new DataSet('branch', array('error' => true, 'message'=>$e->getMessage())));
		}
	}

}