function Utilities() {

	var self = this;

	this.frontVersion = "1.0.0";

	this.zerofillNumberFormat = function(number, length) {
		if(typeof number == 'number') {
			number = number.toString(); 
		}
		var baseZeroFill = "0";
		var zeroFilledStringLength = self.stringRepeat(baseZeroFill, length);
		var concatenadBasePlusNumber =  zeroFilledStringLength + number;
		return concatenadBasePlusNumber.slice(-length);
	};

	this.stringRepeat = function(string, qtd) { //the same as str.repeat() ES6
		var finalString = [];
		while(finalString.length < qtd){
			finalString.push(string);
		}
		return finalString.join('');
	};

	this.clearAllTimeOutsAndIntervals = function() {
        var lastTimeOutId = window.setTimeout(function(){}, 0);
        while (lastTimeOutId > 0) {
            clearTimeout(lastTimeOutId);
            clearInterval(lastTimeOutId);
            lastTimeOutId --;
        }
	};

	this.capitalizeFirstLetter = function(string) {
	    return string.charAt(0).toUpperCase() + string.slice(1);
	};

	this.uniqueArray = function(toBecomeUniqueArray) {
		return toBecomeUniqueArray.filter(function(item, pos) {
		    return toBecomeUniqueArray.indexOf(item) == pos;
		});
	};

	this.groupArrayByProperty = function(toGroupArray, property) {
		var groupedObject = {};
		toGroupArray.forEach(function(item) {
			if(!item[property]) {
				item[property] = null;
			}
			if(!groupedObject.hasOwnProperty(item[property])) {
				groupedObject[item[property]] = [];
			}
			groupedObject[item[property]].push(item);
		});
		return groupedObject;
	};

	String.prototype.moneyToFloat = function () {
		var treated = this.replace('R$', '');
		treated = treated.replace(' ', '');
		treated = treated.replace(',', '.');
		return parseFloat(treated);
	};

	Number.prototype.moneyToFloat = function () {
		return parseFloat(this);
	};

	String.prototype.replaceAt = function(index, character) {
	    return this.substr(0, index) + character + this.substr(index+character.length);
	};

	Number.prototype.toMoney = function () {
		var treated = "";
		var splited = this.toString().split('.');
		if (parseFloat(this).isInt()) {
			treated = this + ',00';
		} else if (parseFloat(splited[1]) < 10) {
			splited[1] += '0';
			treated = splited[0] + ',' + splited[1];
		} else {
			treated = this;
		}

		treated = treated.replace('.', ',');
		treated = 'R$ ' + treated;
		return treated;
	};

	Number.prototype.isInt = function () {
		return this % 1 === 0;
	};

	this.idealTextColor = function(bgColor) {
		// bgColor = tinycolor(bgColor);
		// var red = bgColor._r;
		// var green = bgColor._g;
		// var blue = bgColor._b;
		// var textColor;
		// if ((red*0.299 + green*0.587 + blue*0.114) > 203) {
		// 	textColor = '#000000';
		// } else {
		// 	textColor = '#ffffff';
		// }
		// return textColor;
		// return tinycolor.mostReadable(bgColor, ['#FFF', '#000']).toHexString();

		let textColor;
		const luminance = getLuminance(bgColor);
		if (luminance > 0.5) {
			textColor = '#000000'; // Set text color to black
		} else {
			textColor = '#FFFFFF'; // Set text color to white
  		}

		return textColor;
	};

	function getLuminance(color) {
		// Convert hex color to RGB
		const rgb = hexToRgb(color);
		// Calculate relative luminance
		const r = adjustGamma(rgb.r / 255);
		const g = adjustGamma(rgb.g / 255);
		const b = adjustGamma(rgb.b / 255);
		const luminance = 0.2126 * r + 0.7152 * g + 0.0722 * b;
		return luminance;
	  }
	  
	  // Convert a hex color to an RGB object
	function hexToRgb(hex) {
		const shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
		hex = hex.replace(shorthandRegex, (m, r, g, b) => r + r + g + g + b + b);
		const result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
		return result ? { r: parseInt(result[1], 16), g: parseInt(result[2], 16), b: parseInt(result[3], 16) } : null;
	}
	  
	  // Adjust the gamma of a color component
	function adjustGamma(component) {
		if (component <= 0.03928) {
			return component / 12.92;
		} else {
			return Math.pow((component + 0.055) / 1.055, 2.4);
		}
	}

}

Configuration(function(ContextRegister) {
	ContextRegister.register('Utilities', Utilities);
});